/* Copyright 2021 The TensorFlow Authors. All Rights Reserved.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
==============================================================================*/

#ifndef TENSORFLOW_COMPILER_MLIR_TFRT_JIT_TRANSFORMS_TF_JITRT_TEST_PASSES_H_
#define TENSORFLOW_COMPILER_MLIR_TFRT_JIT_TRANSFORMS_TF_JITRT_TEST_PASSES_H_

#include <memory>

#include "mlir/Pass/Pass.h"
#include "mlir/Pass/PassManager.h"
#include "mlir/Dialect/Func/IR/FuncOps.h"  // from @llvm-project

namespace tensorflow {

#define GEN_PASS_DECL_TESTCLUSTERING
#define GEN_PASS_DECL_TESTCLUSTERINGPOLICY
#include "tensorflow/compiler/mlir/tfrt/jit/transforms/tf_jitrt_test_passes.h.inc"

// See `tf_jitrt_test_passes.td` for the passes documentation.
std::unique_ptr<mlir::OperationPass<mlir::func::FuncOp>>
CreateTestTfJitRtClusteringPass();
std::unique_ptr<mlir::OperationPass<mlir::func::FuncOp>>
CreateTestTfJitRtClusteringPolicyPass();

}  // namespace tensorflow

#define GEN_PASS_REGISTRATION
#include "tensorflow/compiler/mlir/tfrt/jit/transforms/tf_jitrt_test_passes.h.inc"

#endif  // TENSORFLOW_COMPILER_MLIR_TFRT_JIT_TRANSFORMS_TF_JITRT_TEST_PASSES_H_
