"""TensorFlow V2 API __init__.py files."""

# keep sorted
TENSORFLOW_API_INIT_FILES = [
    # BEGIN GENERATED FILES
    "__init__.py",
    "__internal__/__init__.py",
    "__internal__/autograph/__init__.py",
    "__internal__/decorator/__init__.py",
    "__internal__/dispatch/__init__.py",
    "__internal__/distribute/__init__.py",
    "__internal__/distribute/combinations/__init__.py",
    "__internal__/distribute/interim/__init__.py",
    "__internal__/distribute/multi_process_runner/__init__.py",
    "__internal__/eager_context/__init__.py",
    "__internal__/feature_column/__init__.py",
    "__internal__/function/__init__.py",
    "__internal__/graph_util/__init__.py",
    "__internal__/mixed_precision/__init__.py",
    "__internal__/monitoring/__init__.py",
    "__internal__/nest/__init__.py",
    "__internal__/ops/__init__.py",
    "__internal__/smart_cond/__init__.py",
    "__internal__/test/__init__.py",
    "__internal__/test/combinations/__init__.py",
    "__internal__/tf2/__init__.py",
    "__internal__/train/__init__.py",
    "__internal__/types/__init__.py",
    "__internal__/types/data/__init__.py",
    "__internal__/saved_model/__init__.py",
    "__internal__/saved_model/load/__init__.py",
    "__internal__/tracking/__init__.py",
    "__operators__/__init__.py",
    "audio/__init__.py",
    "autograph/__init__.py",
    "autograph/experimental/__init__.py",
    "autodiff/__init__.py",
    "bitwise/__init__.py",
    "compat/__init__.py",
    "config/__init__.py",
    "config/experimental/__init__.py",
    "config/optimizer/__init__.py",
    "config/threading/__init__.py",
    "data/__init__.py",
    "data/experimental/__init__.py",
    "data/experimental/service/__init__.py",
    "debugging/__init__.py",
    "debugging/experimental/__init__.py",
    "distribute/__init__.py",
    "distribute/cluster_resolver/__init__.py",
    "distribute/coordinator/__init__.py",
    "distribute/experimental/__init__.py",
    "distribute/experimental/coordinator/__init__.py",
    "distribute/experimental/partitioners/__init__.py",
    "distribute/experimental/rpc/__init__.py",
    "dtypes/__init__.py",
    "dtypes/experimental/__init__.py",
    "errors/__init__.py",
    "experimental/__init__.py",
    "experimental/extension_type/__init__.py",
    "experimental/dtensor/__init__.py",
    "experimental/numpy/__init__.py",
    "experimental/numpy/random/__init__.py",
    "experimental/tensorrt/__init__.py",
    "experimental/dlpack/__init__.py",
    "feature_column/__init__.py",
    "io/gfile/__init__.py",
    "graph_util/__init__.py",
    "image/__init__.py",
    "io/__init__.py",
    "queue/__init__.py",
    "linalg/__init__.py",
    "linalg/experimental/__init__.py",
    "lite/__init__.py",
    "lite/experimental/__init__.py",
    "lite/experimental/authoring/__init__.py",
    "lite/experimental/microfrontend/__init__.py",
    "lite/experimental/microfrontend/python/__init__.py",
    "lite/experimental/microfrontend/python/ops/__init__.py",
    "lookup/__init__.py",
    "lookup/experimental/__init__.py",
    "math/__init__.py",
    "math/special/__init__.py",
    "mlir/__init__.py",
    "mlir/experimental/__init__.py",
    "nest/__init__.py",
    "nn/__init__.py",
    "nn/experimental/__init__.py",
    "profiler/__init__.py",
    "profiler/experimental/__init__.py",
    "profiler/experimental/client/__init__.py",
    "profiler/experimental/server/__init__.py",
    "quantization/__init__.py",
    "ragged/__init__.py",
    "random/__init__.py",
    "random/experimental/__init__.py",
    "raw_ops/__init__.py",
    "saved_model/__init__.py",
    "saved_model/experimental/__init__.py",
    "sets/__init__.py",
    "signal/__init__.py",
    "sparse/__init__.py",
    "strings/__init__.py",
    "summary/__init__.py",
    "summary/experimental/__init__.py",
    "sysconfig/__init__.py",
    "test/__init__.py",
    "test/experimental/__init__.py",
    "tpu/experimental/embedding/__init__.py",
    "tpu/experimental/__init__.py",
    "tpu/__init__.py",
    "train/__init__.py",
    "train/experimental/__init__.py",
    "types/__init__.py",
    "types/experimental/__init__.py",
    "types/experimental/distributed/__init__.py",
    "version/__init__.py",
    "xla/__init__.py",
    "xla/experimental/__init__.py",
    # END GENERATED FILES
]

KERAS_API_INIT_FILES = [
    "__init__.py",
    "keras/__init__.py",
    "keras/__internal__/__init__.py",
    "keras/__internal__/backend/__init__.py",
    "keras/__internal__/models/__init__.py",
    "keras/__internal__/losses/__init__.py",
    "keras/__internal__/layers/__init__.py",
    "keras/__internal__/optimizers/__init__.py",
    "keras/__internal__/utils/__init__.py",
    "keras/activations/__init__.py",
    "keras/applications/__init__.py",
    "keras/applications/densenet/__init__.py",
    "keras/applications/efficientnet/__init__.py",
    "keras/applications/imagenet_utils/__init__.py",
    "keras/applications/inception_resnet_v2/__init__.py",
    "keras/applications/inception_v3/__init__.py",
    "keras/applications/mobilenet/__init__.py",
    "keras/applications/mobilenet_v2/__init__.py",
    "keras/applications/mobilenet_v3/__init__.py",
    "keras/applications/nasnet/__init__.py",
    "keras/applications/resnet/__init__.py",
    "keras/applications/resnet_v2/__init__.py",
    "keras/applications/resnet50/__init__.py",
    "keras/applications/vgg16/__init__.py",
    "keras/applications/vgg19/__init__.py",
    "keras/applications/xception/__init__.py",
    "keras/backend/__init__.py",
    "keras/callbacks/__init__.py",
    "keras/callbacks/experimental/__init__.py",
    "keras/constraints/__init__.py",
    "keras/datasets/__init__.py",
    "keras/datasets/boston_housing/__init__.py",
    "keras/datasets/cifar10/__init__.py",
    "keras/datasets/cifar100/__init__.py",
    "keras/datasets/fashion_mnist/__init__.py",
    "keras/datasets/imdb/__init__.py",
    "keras/datasets/mnist/__init__.py",
    "keras/datasets/reuters/__init__.py",
    "keras/estimator/__init__.py",
    "keras/experimental/__init__.py",
    # Placeholder for internal API
    "keras/initializers/__init__.py",
    "keras/layers/__init__.py",
    "keras/layers/experimental/__init__.py",
    "keras/layers/experimental/preprocessing/__init__.py",
    "keras/losses/__init__.py",
    "keras/metrics/__init__.py",
    "keras/mixed_precision/__init__.py",
    "keras/premade/__init__.py",
    "keras/models/__init__.py",
    "keras/optimizers/__init__.py",
    "keras/optimizers/experimental/__init__.py",
    "keras/optimizers/schedules/__init__.py",
    "keras/preprocessing/__init__.py",
    "keras/preprocessing/image/__init__.py",
    "keras/preprocessing/sequence/__init__.py",
    "keras/preprocessing/text/__init__.py",
    "keras/regularizers/__init__.py",
    "keras/utils/__init__.py",
    "keras/utils/experimental/__init__.py",
    "keras/utils/legacy/__init__.py",
    "keras/wrappers/__init__.py",
    "keras/wrappers/scikit_learn/__init__.py",
]
